﻿Imports C1.Silverlight
Imports C1.Silverlight.Chart

Partial Public Class MainPage
    Inherits UserControl

    Dim menu As C1.Silverlight.C1ContextMenu

    Public Sub New()
        InitializeComponent()

        For Each ds As DataSeries In _chart.Data.Children
            AddHandler ds.PlotElementLoaded, AddressOf _Chart_PlotElementLoaded
        Next

        menu = New C1.Silverlight.C1ContextMenu
        Dim menuitem As C1MenuItem = New C1MenuItem
        menuitem.Header = "BackGround"
        AddHandler menuitem.Click, AddressOf Me.menuitem_Click
        menu.Items.Add(menuitem)

        menuitem = New C1MenuItem
        menuitem.Header = "Reset Background"
        menuitem.Visibility = System.Windows.Visibility.Collapsed
        AddHandler menuitem.Click, AddressOf Me.menuitem_Click
        menu.Items.Add(menuitem)

    End Sub

    Private Sub menuitem_Click(ByVal sender As Object, ByVal e As SourcedEventArgs)
        Dim currMenu As C1MenuItem = CType(sender, C1MenuItem)
        If (currMenu.Header.ToString = "BackGround") Then
            If (Not (currentPE) Is Nothing) Then
                CType(currentPE.Content, Path).Tag = CType(currentPE.Content, Path).Fill
                CType(currentPE.Content, Path).Fill = New SolidColorBrush(Colors.Gray)
            End If
        Else
            CType(currentPE.Content, Path).Fill = CType(CType(currentPE.Content, Path).Tag, SolidColorBrush)
            CType(currentPE.Content, Path).Tag = Nothing
        End If
    End Sub

    ''' <summary>
    ''' Cancel the Default Silverlight Menu from Chart Object
    ''' </summary>    
    Private Sub _chart_MouseRightButtonDown(sender As Object, e As System.Windows.Input.MouseButtonEventArgs) Handles _chart.MouseRightButtonDown
        e.Handled = True
    End Sub

    Private Sub _Chart_PlotElementLoaded(ByVal sender As Object, ByVal e As EventArgs)
        AddHandler CType(sender, PlotElement).MouseRightButtonUp, AddressOf PlotElement_MouseRightButtonUp
        AddHandler CType(sender, PlotElement).MouseRightButtonDown, AddressOf PlotElement_MouseRightButtonDown
    End Sub

    ' Holds reference to currently selected PlotElement Object     
    Dim currentPE As PlotElement

    ''' <summary>
    ''' 1. Cancel the default Silverlight ContextMenu
    ''' 2. Stores the reference of current PlotElement in variable 'currentPE
    ''' </summary>    
    Private Sub PlotElement_MouseRightButtonDown(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        currentPE = CType(sender, PlotElement)
        e.Handled = True
    End Sub

    ''' <summary>
    ''' Toggles the visibility of MenuItems based on the current
    ''' background applied on the PlotElement
    ''' </summary>
    Private Sub PlotElement_MouseRightButtonUp(ByVal sender As Object, ByVal e As MouseButtonEventArgs)

        If currentPE IsNot CType(sender, PlotElement) Then
            Return
        End If

        If (Not (CType(currentPE.Content, Path).Tag) Is Nothing) Then
            CType(menu.Items(0), C1MenuItem).Visibility = System.Windows.Visibility.Collapsed
            CType(menu.Items(1), C1MenuItem).Visibility = System.Windows.Visibility.Visible
        Else
            CType(menu.Items(0), C1MenuItem).Visibility = System.Windows.Visibility.Visible
            CType(menu.Items(1), C1MenuItem).Visibility = System.Windows.Visibility.Collapsed
        End If

        menu.Show(currentPE, e.GetPosition(currentPE))
    End Sub

End Class